///::///////////////////////////////////////////////
//:: Acid Fog: On Enter
//:: NW_S0_AcidFogA.nss
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    All creatures within the AoE take 2d6 acid damage
    per round and upon entering if they fail a Fort Save
    their movement is halved.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: May 17, 2001
//:://////////////////////////////////////////////

//#include "X0_I0_SPELLS"
#include "x2_inc_spellhook"
#include "nw_i0_spells"
#include "prc_inc_spells"

void main()
{

    //Declare major variables
    int nMetaMagic = PRCGetMetaMagicFeat();
    int nDamage;
    effect eDam;
    effect eVis = EffectVisualEffect(VFX_DUR_FLIES);
    effect eSlow = EffectAbilityDecrease(ABILITY_CONSTITUTION,d6());
    effect eCessate = EffectVisualEffect(VFX_DUR_CESSATE_NEGATIVE);
    eSlow = EffectLinkEffects(eCessate,eSlow);
     eSlow = EffectLinkEffects(eVis,eSlow);
    eSlow = ExtraordinaryEffect (eSlow);
    object oTarget = GetEnteringObject();
    float fDelay = GetRandomDelay(1.0, 2.2);
    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, GetAreaOfEffectCreator()))
    {
        //Fire cast spell at event for the target
        SignalEvent(oTarget, EventSpellCastAt(GetAreaOfEffectCreator(), SPELL_MIND_FOG));
        //Spell resistance check


            //Make a Fortitude Save to avoid the effects of the movement hit.
            if(!PRCMySavingThrow(SAVING_THROW_FORT, oTarget, 18, SAVING_THROW_TYPE_DISEASE, GetAreaOfEffectCreator(), fDelay))
            {
                //lose con effect
                ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eSlow, oTarget,240.0);
            }

    }
}
