//:://////////////////////////////////////////////////////////////////////////////////////
//:: Balor On Death
//:: NW_S3_BALORDETH
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Fireball explosion does 50 damage to all within
    20ft
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 9, 2002
//:://////////////////////////////////////////////
#include "jw_exp_giver"
#include "NW_I0_SPELLS"
#include "prc_inc_spells"

void main()
{
    //Declare major variables
    object oCaster = OBJECT_SELF;
    int nMetaMagic = PRCGetMetaMagicFeat();
    int nDamage;
    float fDelay;
    effect eExplode = EffectVisualEffect(VFX_FNF_FIREBALL);
    effect eVis = EffectVisualEffect(VFX_IMP_FLAME_M);
    effect eDam;
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetLocation(OBJECT_SELF);
    //Limit Caster level for the purposes of damage
    //Apply the fireball explosion at the location captured above.
    ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eExplode, lTarget);
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR);
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
       //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_FIREBALL));
        //Get the distance between the explosion and the target to calculate delay
        fDelay = GetDistanceBetweenLocations(lTarget, GetLocation(oTarget))/20;
        if (!PRCDoResistSpell(OBJECT_SELF, oTarget, FloatToInt(fDelay)))
        {
            //Adjust the damage based on the Reflex Save, Evasion and Improved Evasion.
            nDamage = PRCGetReflexAdjustedDamage(50, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_FIRE);
            //Set the damage effect
            eDam = EffectDamage(nDamage, DAMAGE_TYPE_FIRE);
            if(nDamage > 0)
            {
                // Apply effects to the currently selected target.
                DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));
                //This visual effect is applied to the target object not the location as above.  This visual effect
                //represents the flame that erupts on the target not on the ground.
                DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
            }
         }
       ///Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR);
    }
    string sItem;
    int nRandom = Random(11)+1;
            switch (nRandom)
            {
                case 1: sItem = "nk_fp_balorstaff";         break;
                case 2: sItem = "jw_port_bard";         break;
                case 3: sItem = "jw_melee_brac";         break;
                case 4: sItem = "nk_fp_helmcourag";         break;
                case 5: sItem = "nk_fp_flamingfis";         break;
                case 6: sItem = "nk_fp_srcamulet";         break;
                case 7: sItem = "nk_fp_wzamulet";         break;
                case 8: sItem = "nk_fp_clramulet";         break;
                case 9: sItem = "nk_fp_druamulet";         break;
                case 10: sItem = "jw_port_bard";         break;
                case 11: sItem = "by_barbarianheav";         break;


            }
    CreateItemOnObject(sItem, OBJECT_SELF);
    AssignCommand(OBJECT_SELF, ActionSpeakString("You may defeat me on this plane, but we shall meet again!", TALKVOLUME_TALK));
    location lPortal = GetLocation(GetWaypointByTag("nk_fp_exitportal"));
    CreateObject(OBJECT_TYPE_PLACEABLE, "nk_fp_balorporta", lPortal, TRUE);

object oPC=GetLastKiller();


givexp(OBJECT_SELF,GetLastKiller());
ExecuteScript("prc_npc_death", OBJECT_SELF);

}

