//::///////////////////////////////////////////////
//:: user_bartender
//:: user_bartender.nss
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*

*/
//:://////////////////////////////////////////////
//:: Created By: Lysandius
//:: Created On: 16-07-2002
//:://////////////////////////////////////////////

#include "inc_tavern"

void ActionOpenObject(object oObject);
void ActionCloseObject(object oObject);
void GetDrinks(object oContainer, string sDrink, int nAmount);
void PutBackDrinks();
void PutBackDrink(string sTag, object oContainer);

int GiveDrinks(object oSpeaker);

void main()
{
    int nUser = GetUserDefinedEventNumber();

    if (nUser == 1004) // ON DIALOGUE // PLACE ORDER
    {
        int nState = GetLocalInt(OBJECT_SELF, "nState");

        if (nState == 0)
        {
            SetLocalInt(OBJECT_SELF, "nState", 1);

            SetLocalInt(OBJECT_SELF, "nAle", 0);
            SetLocalInt(OBJECT_SELF, "nWine", 0);
            SetLocalInt(OBJECT_SELF, "nSpirits", 0);

            SetLocalObject(OBJECT_SELF, "oSpeaker", GetLastSpeaker());

            BeginConversation("order_drinks");
        }
        else
        {
            SpeakString("Just a second...");
        }
    }
    if (nUser == 20) // ON ORDER PLACED // GET DRINKS
    {
        int nAle = GetLocalInt(OBJECT_SELF, "nAle");
        int nWine = GetLocalInt(OBJECT_SELF, "nWine");
        int nSpirits = GetLocalInt(OBJECT_SELF, "nSpirits");

        SetLocalInt(OBJECT_SELF, "nState", 1);

        if (nAle > 0 || nWine > 0 || nSpirits > 0)
        {
            SpeakString("Let me get that for you.");

            if (nAle > 0)
            {
                ActionMoveToObject(OBJ_KEG_ALE);
                ActionPlayAnimation(ANIMATION_LOOPING_GET_MID, 1.0, 3.0);
                ActionDoCommand(GetDrinks(OBJ_KEG_ALE, "NW_IT_MPOTION021", nAle));
            }
            if (nWine > 0)
            {
                ActionMoveToObject(OBJ_CRATE_WINE);
                ActionOpenObject(OBJ_CRATE_WINE);
                ActionDoCommand(GetDrinks(OBJ_CRATE_WINE, "NW_IT_MPOTION023", nWine));
                ActionDoCommand(SetLocalString(OBJ_CRATE_WINE, "sDrink", "NW_IT_MPOTION023"));
                ActionDoCommand(SignalEvent(OBJ_CRATE_WINE, EventUserDefined(1008))); // ON DISTURBED
                ActionCloseObject(OBJ_CRATE_WINE);
            }
            if (nSpirits > 0)
            {
                ActionMoveToObject(OBJ_CRATE_SPIRITS);
                ActionOpenObject(OBJ_CRATE_SPIRITS);
                ActionDoCommand(GetDrinks(OBJ_CRATE_SPIRITS, "NW_IT_MPOTION022", nSpirits));
                ActionDoCommand(SetLocalString(OBJ_CRATE_SPIRITS, "sDrink", "NW_IT_MPOTION022"));
                ActionDoCommand(SignalEvent(OBJ_CRATE_SPIRITS, EventUserDefined(1008))); // ON DISTURBED
                ActionCloseObject(OBJ_CRATE_SPIRITS);
            }

            ActionMoveToObject(OBJ_WAYPOINT_BAR);

            ActionDoCommand(SignalEvent(OBJECT_SELF, EventUserDefined(30))); // ON GOT DRINKS
        }
        else
            SetLocalInt(OBJECT_SELF, "nState", 0);
    }
    if (nUser == 30) // ON GOT DRINKS // GIVE DRINKS
    {
        object oSpeaker = GetLocalObject(OBJECT_SELF, "oSpeaker");
        int nGold;

        if (GetDistanceToObject(oSpeaker) < 15.0)
        {
            nGold = GiveDrinks(oSpeaker);
            string sAreaName = GetTag(GetArea(OBJECT_SELF));
            string sVarName = "RPO_" + sAreaName + "_Bill";
            SetLocalInt(oSpeaker, sVarName, GetLocalInt(oSpeaker, sVarName) + nGold);

            if (nGold)
            {
                SpeakString("Here you go.");
                if (GetLocalInt(OBJECT_SELF, "nWine") || GetLocalInt(OBJECT_SELF, "nSpirits"))
                    SpeakString("We ran out of drinks so your order is not complete.");
                SpeakString("That will be " + IntToString(nGold) + " gold pieces please.");
            }
            else
                SpeakString("We ran out of drinks. Please come back later.");

            SetLocalInt(OBJECT_SELF, "nAle", 0);
            SetLocalInt(OBJECT_SELF, "nWine", 0);
            SetLocalInt(OBJECT_SELF, "nSpirits", 0);

            SetLocalInt(OBJECT_SELF, "nState", 0);
        }
        else
        {
            SpeakString("Where did my customer go?");
            SignalEvent(OBJECT_SELF, EventUserDefined(40)); // ON CUSTOMER GONE
        }
    }
    if (nUser == 40) // ON CUSTOMER GONE // PUT BACK DRINKS
    {
        object oItem = GetFirstItemInInventory();

        SetLocalInt(OBJECT_SELF, "nAle", 0);
        SetLocalInt(OBJECT_SELF, "nWine", 0);
        SetLocalInt(OBJECT_SELF, "nSpirits", 0);

        while (GetIsObjectValid(oItem))
        {
            string sTag = GetTag(oItem);
            if (sTag == "NW_IT_MPOTION021")
            {
                SetLocalInt(OBJECT_SELF, "nAle", 1);
            }
            else if (sTag == "NW_IT_MPOTION023")
            {
                SetLocalInt(OBJECT_SELF, "nWine", 1);
            }
            else if (sTag == "NW_IT_MPOTION022")
            {
                SetLocalInt(OBJECT_SELF, "nSpirits", 1);
            }
            oItem = GetNextItemInInventory();
        }

        if (GetLocalInt(OBJECT_SELF, "nAle") || GetLocalInt(OBJECT_SELF, "nWine") || GetLocalInt(OBJECT_SELF, "nSpirits"))
            PutBackDrinks();
        else
            SetLocalInt(OBJECT_SELF, "nState", 0);
    }
}

void ActionOpenObject(object oObject)
{
    ActionDoCommand(AssignCommand(oObject, DelayCommand(0.5, ActionPlayAnimation(ANIMATION_PLACEABLE_OPEN, 1.0, 2.0))));
    ActionPlayAnimation(ANIMATION_LOOPING_GET_MID, 1.0, 3.0);
}

void ActionCloseObject(object oObject)
{
    ActionDoCommand(AssignCommand(oObject, ActionPlayAnimation(ANIMATION_PLACEABLE_CLOSE, 1.0, 2.0)));
}

void GetDrinks(object oContainer, string sDrink, int nAmount)
{
    if (sDrink == "NW_IT_MPOTION021")
    {
        while (nAmount > 0)
        {
            CreateItemOnObject("NW_IT_MPOTION021");
            nAmount--;
        }
        AssignCommand(oContainer, PlaySound("it_potion"));
        SetLocalInt(OBJECT_SELF, "nAle", nAmount);
    }

    if (sDrink == "NW_IT_MPOTION023" || sDrink == "NW_IT_MPOTION022")
    {
        int nLeft = TransferItem(OBJECT_SELF, oContainer, sDrink, nAmount);
        if (sDrink == "NW_IT_MPOTION023")
            SetLocalInt(OBJECT_SELF, "nWine", nLeft);
        else if (sDrink == "NW_IT_MPOTION022")
            SetLocalInt(OBJECT_SELF, "nSpirits", nLeft);
    }
}

int GiveDrinks(object oSpeaker)
{
    int nAle;
    int nWine;
    int nSpirits;
    int nGold;

    object oItem = GetFirstItemInInventory();
    while (GetIsObjectValid(oItem))
    {
        string sTag = GetTag(oItem);
        if (sTag == "NW_IT_MPOTION021")
        {
            nAle += GetNumStackedItems(oItem);
        }
        if (sTag == "NW_IT_MPOTION022")
        {
            nSpirits += GetNumStackedItems(oItem);
        }
        if (sTag == "NW_IT_MPOTION023")
        {
            nWine += GetNumStackedItems(oItem);
        }
        oItem = GetNextItemInInventory();
    }

    nGold = nAle * 2 + nWine * 4 + nSpirits * 6;

    TransferItem(oSpeaker, OBJECT_SELF, "NW_IT_MPOTION021", nAle);
    TransferItem(oSpeaker, OBJECT_SELF, "NW_IT_MPOTION022", nSpirits);
    TransferItem(oSpeaker, OBJECT_SELF, "NW_IT_MPOTION023", nWine);

    return nGold;
}

void PutBackDrinks()
{
    int nAle = GetLocalInt(OBJECT_SELF, "nAle");
    int nWine = GetLocalInt(OBJECT_SELF, "nWine");
    int nSpirits = GetLocalInt(OBJECT_SELF, "nSpirits");

    if (nAle)
    {
        ActionMoveToObject(OBJ_KEG_ALE);
        ActionPlayAnimation(ANIMATION_LOOPING_GET_MID, 1.0, 3.0);
        ActionDoCommand(PutBackDrink("NW_IT_MPOTION021", OBJ_KEG_ALE));
    }
    if (nWine)
    {
        ActionMoveToObject(OBJ_CRATE_WINE);
        ActionOpenObject(OBJ_CRATE_WINE);
        ActionDoCommand(PutBackDrink("NW_IT_MPOTION023", OBJ_CRATE_WINE));
        ActionCloseObject(OBJ_CRATE_WINE);
    }
    if (nSpirits)
    {
        ActionMoveToObject(OBJ_CRATE_SPIRITS);
        ActionOpenObject(OBJ_CRATE_SPIRITS);
        ActionDoCommand(PutBackDrink("NW_IT_MPOTION022", OBJ_CRATE_SPIRITS));
        ActionCloseObject(OBJ_CRATE_SPIRITS);
    }
    ActionMoveToObject(OBJ_WAYPOINT_BAR);
    ActionDoCommand(SetLocalInt(OBJECT_SELF, "nState", 0));
}

void PutBackDrink(string sTag, object oContainer)
{
    int nWine;
    int nSpirits;

    object oItem = GetFirstItemInInventory();
    while (GetIsObjectValid(oItem))
    {
        string sTag = GetTag(oItem);
        if (sTag == "NW_IT_MPOTION021")
        {
            DestroyObject(oItem);
        }
        if (sTag == "NW_IT_MPOTION022")
        {
            nSpirits += GetNumStackedItems(oItem);
        }
        if (sTag == "NW_IT_MPOTION023")
        {
            nWine += GetNumStackedItems(oItem);
        }
        oItem = GetNextItemInInventory();
    }
    TransferItem(OBJ_CRATE_SPIRITS, OBJECT_SELF, "NW_IT_MPOTION022", nSpirits);
    TransferItem(OBJ_CRATE_WINE, OBJECT_SELF, "NW_IT_MPOTION023", nWine);
}
