//:://////////////////////////////////////////////////
//:: jw_treasure_gene.nss
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
// *



// * TREASURE GENERATION FUNCTIONS
// *
    // *
    // * Non-Scaling Treasure
    // *
    void CreateBook(object oTarget)
    {
    oTarget=OBJECT_SELF;
        int nBook1 = Random(31) + 1;
        string sRes = "NW_IT_BOOK01";

        if (nBook1 < 10)
        {
            sRes = "NW_IT_BOOK00" + IntToString(nBook1);
        }
        else
        {
            sRes = "NW_IT_BOOK0" + IntToString(nBook1);
        }

        CreateItemOnObject(sRes, OBJECT_SELF);
    }

    void CreateAnimalPart(object oTarget)
    {

        string sRes = "";
        int nResult = Random(3) + 1;
        switch (nResult)
        {
            case 1: sRes = "NW_IT_MSMLMISC20"; break;
            case 2: sRes = "NW_IT_MMIDMISC05"; break;
            case 3: sRes = "NW_IT_MMIDMISC06"; break;
        }

        CreateItemOnObject(sRes, OBJECT_SELF);
    }

    void CreateJunk(object oTarget)
    {
        string sRes = "NW_IT_TORCH001";
        int NUM_ITEMS = 6;
        int nResult = Random(NUM_ITEMS) + 1;
        int nKit = 0;
        switch (nResult)
        {
            case 1: sRes = "NW_IT_MPOTION021"; break; //ale
            case 2: sRes = "NW_IT_MPOTION021"; break;   // ale
            case 3: sRes = "NW_IT_MPOTION023"; break; // wine
            case 4: sRes = "NW_IT_MPOTION021"; break; // ale
            case 5: sRes = "NW_IT_MPOTION022"; break; // spirits
            case 6: sRes = "NW_IT_TORCH001"; break; //torch
        }

        CreateItemOnObject(sRes, OBJECT_SELF);
    }
    // *
    // * Scaling Treasure
    // *
    void CreateGold(int nRange, int nTreasureType)
    {


        int nAmount;


        if (nRange==1)
        {
            nAmount = d10();
        }
        else if (nRange==2)
        {
            nAmount = d20();
        }
        else if (nRange==3)
        {
            nAmount = d20(2);
        }
        else if (nRange==4)
        {
            nAmount = d20(5);
        }
        else if (nRange==5)
        {
            nAmount = d20(8);
        }
        else if (nRange==6)
        {
            nAmount = d20(10);
        }


        // * always at least 1gp is created
        nAmount = nAmount*nTreasureType;
        if (nAmount <= 0)
        {
            nAmount = 1;
        }

        CreateItemOnObject("NW_IT_GOLD001", OBJECT_SELF, nAmount);
    }

    void CreateGem(int nRange, int nTreasureType)
    {


        string sGem = "nw_it_gem001";          // *** Greenstone ***
        if (nRange==1)
        {
            int nRandom = Random(9) + 1;
            switch (nRandom)
            {
                case 1: sGem = "nw_it_gem001";  break;          // *** Greenstone ***
                case 2: sGem = "nw_it_gem007";  break;          // *** Malachite ***
                case 3: sGem = "nw_it_gem002";  break;          // *** Fire Agate ***
                case 4: case 5: sGem = "nw_it_gem004"; break;          // *** Phenalope ***
                case 6: case 7: sGem = "nw_it_gem014"; break;          // *** Aventurine ***
                case 8: sGem = "nw_it_gem003";         break;          // *** Amethyst ***
                case 9: sGem = "nw_it_gem015";         break;          // *** Fluorspar ***
            }
        }
        else if (nRange==2)               // 30 GP Avg; 150 gp Max
        {
            int nRandom = d12();
            switch (nRandom)
            {
                case 1: sGem = "nw_it_gem001";         break;          // *** Greenstone ***
                case 2: sGem = "nw_it_gem007";         break;          // *** Malachite ***
                case 3: sGem = "nw_it_gem002";         break;          // *** Fire Agate ***
                case 4: sGem = "nw_it_gem004";         break;          // *** Phenalope ***
                case 5: case 6: sGem = "nw_it_gem014";  break;          // *** Aventurine ***
                case 7: case 8: sGem = "nw_it_gem003";  break;          // *** Amethyst ***
                case 9: case 10: sGem = "nw_it_gem015"; break;          // *** Fluorspar ***
                case 11: sGem = "nw_it_gem011";         break;          // *** Garnet ***
                case 12: sGem = "nw_it_gem013";         break;          // *** Alexandrite ***
            }

        }
        else if (nRange==3)  // 75GP Avg; 500 gp max
        {
            int nRandom = d2();
            switch (nRandom)
            {
                case 1: sGem = "nw_it_gem013";         break;          // *** Alexandrite ***
                case 2: sGem = "nw_it_gem010";         break;          // *** Topaz ***

            }

        }
        else if (nRange==4)  // 150 gp avg; 1000 gp max
        {
            int nRandom = d3();
            switch (nRandom)
            {
                case 1: sGem = "nw_it_gem013";  break;          // *** Alexandrite ***
                case 2: sGem = "nw_it_gem010";    break;          // *** Topaz ***
                case 3: sGem = "nw_it_gem008";           break;          // *** Sapphire ***
                 case 4: sGem = "jw_emerald";           break;          // *** Emerald ***
            }
        }
        else if (nRange==5)  // 300 gp avg; any
        {
            int nRandom = d6();
            switch (nRandom)
            {
                case 1: sGem = "nw_it_gem013";  break;          // *** Alexandrite ***
                case 2: sGem = "nw_it_gem010";    break;          // *** Topaz ***
                case 3: case 4: sGem = "nw_it_gem008";           break;          // *** Sapphire ***
                case 5: sGem = "nw_it_gem009";           break;          // *** Fire Opal ***
                case 6: sGem = "nw_it_gem009";           break;          // *** Fire Opal ***
                 case 7: sGem = "jw_emerald";           break;          // *** Emerald ***
            }
        }
        else if (nRange==6)// * Anything higher than level 15    500 gp avg; any
        {
            int nRandom = Random(8) + 1;
            switch (nRandom)
            {
                case 1: sGem = "nw_it_gem013";  break;          // *** Alexandrite ***
                case 2: sGem = "nw_it_gem010";    break;          // *** Topaz ***
                case 3: case 4: sGem = "nw_it_gem008";           break;          // *** Sapphire ***
                case 5: sGem = "nw_it_gem009";           break;          // *** Fire Opal ***
                case 6: sGem = "nw_it_gem009";           break;          // *** Fire Opal ***
                case 7: sGem = "nw_it_gem006";           break;          // *** Ruby ***
                case 8: sGem = "jw_emerald";           break;          // *** Emerald ***
            }
        }

      CreateItemOnObject(sGem, OBJECT_SELF, 1);
    }
    void CreateJewel(int nRange, int nTreasureType)
    {


        string sJewel = "";

        if (nRange==1)        // 15 gp avg; 75 gp max
        {
          int nRandom = d2();
          switch (nRandom)
          {
            case 1: sJewel = "nw_it_mring021";   break;          // *** Emerald ***
            case 2: sJewel = "nw_it_mneck020";   break;          // *** Emerald ***
          }
        }
        else if (nRange==2)   // 30 GP Avg; 150 gp Max
        {
          int nRandom = d6();
          switch (nRandom)
          {
            case 1: sJewel = "nw_it_mring021";            break;          // *** Emerald ***
            case 2: case 3: sJewel = "nw_it_mneck020";    break;          // *** Emerald ***
            case 4: sJewel = "nw_it_mring022";            break;          // *** Emerald ***
            case 5: case 6: sJewel = "nw_it_mneck023";            break;          }          // *** Emerald ***
        }
        else if (nRange==3)  // 75GP Avg; 500 gp max
        {
          int nRandom = d6();
          switch (nRandom)
          {
            case 1: sJewel = "nw_it_mring021";           break;          // *** Emerald ***
            case 2: case 3: sJewel = "nw_it_mneck020";   break;          // *** Emerald ***
            case 4: case 5: sJewel = "nw_it_mring022";   break;          // *** Emerald ***
            case 6: sJewel = "nw_it_mneck021";           break;          // *** Emerald ***
          }
        }
        else if (nRange==4)  // 150 gp avg; 1000 gp max
        {
          int nRandom = d6();
          switch (nRandom)
          {
            case 1: sJewel = "nw_it_mring021";            break;          // *** Emerald ***
            case 2: sJewel = "nw_it_mring022";            break;          // *** Emerald ***
            case 3: case 4: case 5: sJewel = "nw_it_mneck021";    break;          // *** Emerald ***
            case 6: sJewel = "nw_it_mring023";            break;          // *** Emerald ***
          }
        }
        else if (nRange==5)  // 300 gp avg; any
        {
          int nRandom = d8();
          switch (nRandom)
          {
            case 1: sJewel = "nw_it_mring022";           break;          // *** Emerald ***
            case 2: case 3: sJewel = "nw_it_mneck021";   break;          // *** Emerald ***
            case 4: case 5: case 6: sJewel = "nw_it_mring023"; break;          // *** Emerald ***
            case 7: case 8: sJewel = "nw_it_mneck022";               break;          // *** Emerald ***
          }
        }
        else if (nRange==6)
        {
          int nRandom = d6();
          switch (nRandom)
          {
            case 1: sJewel = "nw_it_mring022";              break;          // *** Emerald ***
            case 2: sJewel = "nw_it_mneck021";              break;          // *** Emerald ***
            case 3: case 4: sJewel = "nw_it_mring023";      break;          // *** Emerald ***
            case 5: case 6: sJewel = "nw_it_mneck022";      break;          // *** Emerald ***
          }
        }


      CreateItemOnObject(sJewel, OBJECT_SELF, 1);

    }
    // * returns the valid upper limit for any arcane spell scroll
    int TrimLevel(int nScroll, int nLevel)
    {   int nMax = 5;
        switch (nLevel)
        {
            case 0: nMax = 4; break;
            case 1: nMax = 13; break;
            case 2: nMax = 21; break;
            case 3: nMax = 15; break;
            case 4: nMax = 17; break;
            case 5: nMax = 13; break;
            case 6: nMax = 14; break;
            case 7: nMax = 8; break;
            case 8: nMax = 9; break;
            case 9: nMax = 12; break;
        }
        if (nScroll > nMax)
        {
        nScroll = nMax;
        }
        return nScroll;

    }
    // * nModifier is to 'raise' the level of the oAdventurer
    void CreateArcaneScroll(int nRange)
    {
        int nMaxSpells = 21;


        int nScroll = 1;
        int nLevel = 1;

        if (nRange==1)           // l 1-2
        {
          nLevel = d2();
          nScroll =  Random(nMaxSpells) + 1;
        }
        else if (nRange==2)      // l 1-4
        {
          nLevel = d4();
          nScroll =  Random(nMaxSpells) + 1;
        }
        else if (nRange==3)    // l 2-6
        {
          nLevel = d6();
          if (nLevel < 2) nLevel = 2;

          nScroll =  Random(nMaxSpells) + 1;
        }
        else if (nRange==4)   // l 3-8
        {
          nLevel = d8();
          if (nLevel < 3) nLevel = 3;

          nScroll =  Random(nMaxSpells) + 1;
        }
        else if (nRange==5)   // l 4-9
        {
          nLevel = d8() + 1;
          if (nLevel < 4) nLevel = 4;

          nScroll =  Random(nMaxSpells) + 1;
        }
        else if (nRange==6)   // 5 -9
        {
          nLevel = d8() + 1;
          if (nLevel < 5) nLevel = 5;

          nScroll =  Random(nMaxSpells) + 1;
        }

        // * Trims the level of the scroll to match the max # of scrolls in each level range
        nScroll = TrimLevel(nScroll, nLevel);

        string sRes = "nw_it_sparscr216";          // *** Knock ***

        if (nScroll < 10)
        {
            sRes = "NW_IT_SPARSCR" + IntToString(nLevel) + "0" + IntToString(nScroll);
        }
        else
        {
            sRes = "NW_IT_SPARSCR" + IntToString(nLevel) + IntToString(nScroll);
        }
          CreateItemOnObject(sRes, OBJECT_SELF, 1);
        }

    void CreateDivineScroll(int nRange)
    {


        string sScroll = "";
        if (nRange==1)
        {
            int nRandom = d4();
            switch (nRandom)
            {
                case 1: sScroll = "nw_it_spdvscr201"; break;          // *** Lesser Restoration ***
                case 2: sScroll = "nw_it_spdvscr202"; break;          // *** Charm Person or Animal ***
                case 3: sScroll = "nw_it_spdvscr203"; break;          // *** Silence ***
                case 4: sScroll = "nw_it_spdvscr204"; break;          // *** Sound Burst ***
            }
        }
        else if (nRange==2)
        {
            int nRandom = d8();
            switch (nRandom)
            {
                case 1: sScroll = "nw_it_spdvscr201"; break;          // *** Lesser Restoration ***
                case 2: sScroll = "nw_it_spdvscr202";break;          // *** Charm Person or Animal ***
                case 3: sScroll = "nw_it_spdvscr203"; break;          // *** Silence ***
                case 4: sScroll = "nw_it_spdvscr204"; break;          // *** Sound Burst ***
                case 5: sScroll = "nw_it_spdvscr301"; break;          // *** Remove Blindness / Deafness ***
                case 6: sScroll = "nw_it_spdvscr302"; break;          // *** Remove Disease ***
                case 7: sScroll = "nw_it_spdvscr401"; break;          // *** Restoration ***
                case 8: sScroll = "nw_it_spdvscr402"; break;          // *** Neutralize Poison ***
            }

        }
        else if (nRange==3)
        {
            int nRandom = Random(9) + 1;
            switch (nRandom)
            {
                case 1: sScroll = "nw_it_spdvscr201"; break;          // *** Lesser Restoration ***
                case 2: sScroll = "nw_it_spdvscr202"; break;          // *** Charm Person or Animal ***
                case 3: sScroll = "nw_it_spdvscr203"; break;          // *** Silence ***
                case 4: sScroll = "nw_it_spdvscr204"; break;          // *** Sound Burst ***
                case 5: sScroll = "nw_it_spdvscr301"; break;          // *** Remove Blindness / Deafness ***
                case 6: sScroll = "nw_it_spdvscr302"; break;          // *** Remove Disease ***
                case 7: sScroll = "nw_it_spdvscr401"; break;          // *** Restoration ***
                case 8: sScroll = "nw_it_spdvscr402"; break;          // *** Neutralize Poison ***
                case 9: sScroll = "nw_it_spdvscr501"; break;          // *** Raise Dead ***
            }

        }
        else
        {
            int nRandom = Random(7) + 1;
            switch (nRandom)
            {
                case 1: sScroll = "nw_it_spdvscr301"; break;          // *** Remove Blindness / Deafness ***
                case 2: sScroll = "nw_it_spdvscr302";  break;          // *** Remove Disease ***
                case 3: sScroll = "nw_it_spdvscr401"; break;          // *** Restoration ***
                case 4: sScroll = "nw_it_spdvscr402"; break;          // *** Neutralize Poison ***
                case 5: sScroll = "nw_it_spdvscr501"; break;          // *** Raise Dead ***
                case 6: sScroll = "nw_it_spdvscr701"; break;          // *** Greater Restoration ***
                case 7: sScroll = "nw_it_spdvscr702";  break;          // *** Resurrection ***
            }
        }


        CreateItemOnObject(sScroll, OBJECT_SELF, 1);

    }

    void CreateAmmo(int nRange)
    {


        string sAmmo = "";

        if (nRange==1)           // * 200 gp max
        {
            int nRandom = d3();
            switch (nRandom)
            {
                case 1: sAmmo = "nw_wamar001";  break;          // *** Arrow ***
                case 2: sAmmo = "nw_wambo001";  break;          // *** Bolt ***
                case 3: sAmmo = "nw_wambu001";  break;          // *** Bullet ***
            }
          }
        else if (nRange==2)       // * 800 gp max
        {
            int nRandom = d3();
            switch (nRandom)
            {
                case 1: sAmmo = "nw_wamar001";  break;          // *** Arrow ***
                case 2: sAmmo = "nw_wambo001";  break;          // *** Bolt ***
                case 3: sAmmo = "nw_wambu001";  break;          // *** Bullet ***
            }
        }
        else if (nRange==3)    // *  - 2500 gp
        {
            int nRandom = d3();
            switch (nRandom)
            {
                case 1: sAmmo = "nw_wamar001";  break;          // *** Arrow ***
                case 2: sAmmo = "nw_wambo001";  break;          // *** Bolt ***
                case 3: sAmmo = "nw_wambu001";  break;          // *** Bullet ***
            }
        }
        else
        {
            int nRandom = d3();
            switch (nRandom)
            {
                case 1: sAmmo = "nw_wamar001";  break;          // *** Arrow ***
                case 2: sAmmo = "nw_wambo001";  break;          // *** Bolt ***
                case 3: sAmmo = "nw_wambu001";  break;          // *** Bullet ***
            }
        }

        CreateItemOnObject(sAmmo, OBJECT_SELF, d20(nRange) + 1); // 20 to 120 of the specified ammo type
    }





     void CreateTraps(int nRange)
      {
      string sKit = "";
        if (nRange==1)      // 200
        {
            int nRandom = d3();
            switch (nRandom)
            {
                case 1: sKit = "nw_it_trap001";    break;          // *** Minor Spike Trap Kit ***
                case 2: sKit = "nw_it_trap029";    break;          // *** Minor Frost Trap Kit ***
                case 3: sKit = "nw_it_trap033";    break;          // *** Minor Acid Splash Trap Kit ***
            }
        }
        else if (nRange==2)  // 800
        {
            int nRandom = d12();
            switch (nRandom)
            {
                case 1: sKit = "nw_it_trap001";    break;          // *** Minor Spike Trap Kit ***
                case 2: sKit = "nw_it_trap029";    break;          // *** Minor Frost Trap Kit ***
                case 3: sKit = "nw_it_trap033";    break;          // *** Minor Acid Splash Trap Kit ***
                case 4: sKit = "nw_it_trap002";    break;          // *** Average Spike Trap Kit ***
                case 5: sKit = "nw_it_trap030";    break;          // *** Average Frost Trap Kit ***
                case 6: sKit = "nw_it_trap037";    break;          // *** Minor Sonic Trap Kit ***
                case 7: sKit = "nw_it_trap034";   break;          // *** Average Acid Splash Trap Kit ***
                case 8: sKit = "nw_it_trap005";   break;          // *** Minor Holy Trap Kit ***
                case 9: sKit = "nw_it_trap038";   break;          // *** Average Sonic Trap Kit ***
                case 10: sKit = "nw_it_trap041";   break;          // *** Minor Negative Trap Kit ***
                case 11: sKit = "nw_it_trap003";    break;          // *** Strong Spike Trap Kit ***
                case 12: sKit = "nw_it_trap031";   break;          // *** Strong Frost Trap Kit ***
            }

        }
        else if (nRange==3)   // 200 - 2500
        {
            int nRandom = Random(17) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_trap002";  break;          // *** Average Spike Trap Kit ***
                case 2: sKit = "nw_it_trap030";  break;          // *** Average Frost Trap Kit ***
                case 3: sKit = "nw_it_trap037";  break;          // *** Minor Sonic Trap Kit ***
                case 4: sKit = "nw_it_trap034";   break;          // *** Average Acid Splash Trap Kit ***
                case 5: sKit = "nw_it_trap005";  break;          // *** Minor Holy Trap Kit ***
                case 6: sKit = "nw_it_trap038";   break;          // *** Average Sonic Trap Kit ***
                case 7: sKit = "nw_it_trap041";   break;          // *** Minor Negative Trap Kit ***
                case 8: sKit = "nw_it_trap003";   break;          // *** Strong Spike Trap Kit ***
                case 9: sKit = "nw_it_trap031";   break;          // *** Strong Frost Trap Kit ***
                case 10: sKit = "nw_it_trap035";   break;          // *** Strong Acid Splash Trap Kit ***
                case 11: sKit = "nw_it_trap006";   break;          // *** Average Holy Trap Kit ***
                case 12: sKit = "nw_it_trap042";   break;          // *** Average Negative Trap Kit ***
                case 13: sKit = "nw_it_trap004";   break;          // *** Deadly Spike Trap Kit ***
                case 14: sKit = "nw_it_trap032";   break;          // *** Deadly Frost Trap Kit ***
                case 15: sKit = "nw_it_trap039";    break;          // *** Strong Sonic Trap Kit ***
                case 16: sKit = "nw_it_trap009";   break;          // *** Minor Tangle Trap Kit ***
                case 17: sKit = "nw_it_trap036";   break;          // *** Deadly Acid Splash Trap Kit ***
            }

       }
        else if (nRange==4)  // 800 - 10000
        {
            int nRandom = Random(19) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_trap035";  break;          // *** Strong Acid Splash Trap Kit ***
                case 2: sKit = "nw_it_trap006";  break;          // *** Average Holy Trap Kit ***
                case 3: sKit = "nw_it_trap042";  break;          // *** Average Negative Trap Kit ***
                case 4: sKit = "nw_it_trap004";   break;          // *** Deadly Spike Trap Kit ***
                case 5: sKit = "nw_it_trap032";   break;          // *** Deadly Frost Trap Kit ***
                case 6: sKit = "nw_it_trap039";   break;          // *** Strong Sonic Trap Kit ***
                case 7: sKit = "nw_it_trap009";   break;          // *** Minor Tangle Trap Kit ***
                case 8: sKit = "nw_it_trap036";   break;          // *** Deadly Acid Splash Trap Kit ***
                case 9: sKit = "nw_it_trap013";   break;          // *** Minor Blob of Acid Trap Kit ***
                case 10: sKit = "nw_it_trap040";  break;          // *** Deadly Sonic Trap Kit ***
                case 11: sKit = "nw_it_trap007";  break;          // *** Strong Holy Trap Kit ***
                case 12: sKit = "nw_it_trap043";  break;          // *** Strong Negative Trap Kit ***
                case 13: sKit = "nw_it_trap010";  break;          // *** Average Tangle Trap Kit ***
                case 14: sKit = "nw_it_trap017";  break;          // *** Minor Fire Trap Kit ***
                case 15: sKit = "nw_it_trap021"; break;          // *** Minor Electrical Trap Kit ***
                case 16: sKit = "nw_it_trap014"; break;          // *** Average Blob of Acid Trap Kit ***
                case 17: sKit = "nw_it_trap025"; break;          // *** Minor Gas Trap Kit ***
                case 18: sKit = "nw_it_trap008";  break;          // *** Deadly Holy Trap Kit ***
                case 19: sKit = "nw_it_trap044";  break;          // *** Deadly Negative Trap Kit ***
            }

        }
        else if (nRange==5)  // 2000 -16500
        {
            int nRandom = Random(18) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_trap039";   break;          // *** Strong Sonic Trap Kit ***
                case 2: sKit = "nw_it_trap009";   break;          // *** Minor Tangle Trap Kit ***
                case 3: sKit = "nw_it_trap036";   break;          // *** Deadly Acid Splash Trap Kit ***
                case 4: sKit = "nw_it_trap013";   break;          // *** Minor Blob of Acid Trap Kit ***
                case 5: sKit = "nw_it_trap040";   break;          // *** Deadly Sonic Trap Kit ***
                case 6: sKit = "nw_it_trap007";   break;          // *** Strong Holy Trap Kit ***
                case 7: sKit = "nw_it_trap043";   break;          // *** Strong Negative Trap Kit ***
                case 8: sKit = "nw_it_trap010";  break;          // *** Average Tangle Trap Kit ***
                case 9: sKit = "nw_it_trap017";  break;          // *** Minor Fire Trap Kit ***
                case 10: sKit = "nw_it_trap021";  break;          // *** Minor Electrical Trap Kit ***
                case 11: sKit = "nw_it_trap014";  break;          // *** Average Blob of Acid Trap Kit ***
                case 12: sKit = "nw_it_trap025";  break;          // *** Minor Gas Trap Kit ***
                case 13: sKit = "nw_it_trap008";  break;          // *** Deadly Holy Trap Kit ***
                case 14: sKit = "nw_it_trap044";  break;          // *** Deadly Negative Trap Kit ***
                case 15: sKit = "nw_it_trap018";  break;          // *** Average Fire Trap Kit ***
                case 16: sKit = "nw_it_trap011";  break;          // *** Strong Tangle Trap Kit ***
                case 17: sKit = "nw_it_trap022";  break;          // *** Average Electrical Trap Kit ***
                case 18: sKit = "nw_it_trap026";  break;          // *** Average Gas Trap Kit ***
            }

        }
        else if (nRange==6)   // 2000 - ?
        {
            int nRandom = Random(27) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_trap039";  break;          // *** Strong Sonic Trap Kit ***
                case 2: sKit = "nw_it_trap009";  break;          // *** Minor Tangle Trap Kit ***
                case 3: sKit = "nw_it_trap036";  break;          // *** Deadly Acid Splash Trap Kit ***
                case 4: sKit = "nw_it_trap013";  break;          // *** Minor Blob of Acid Trap Kit ***
                case 5: sKit = "nw_it_trap040";  break;          // *** Deadly Sonic Trap Kit ***
                case 6: sKit = "nw_it_trap007";  break;          // *** Strong Holy Trap Kit ***
                case 7: sKit = "nw_it_trap043";  break;          // *** Strong Negative Trap Kit ***
                case 8: sKit = "nw_it_trap010"; break;          // *** Average Tangle Trap Kit ***
                case 9: sKit = "nw_it_trap017"; break;          // *** Minor Fire Trap Kit ***
                case 10: sKit = "nw_it_trap021"; break;          // *** Minor Electrical Trap Kit ***
                case 11: sKit = "nw_it_trap014"; break;          // *** Average Blob of Acid Trap Kit ***
                case 12: sKit = "nw_it_trap025"; break;          // *** Minor Gas Trap Kit ***
                case 13: sKit = "nw_it_trap008"; break;          // *** Deadly Holy Trap Kit ***
                case 14: sKit = "nw_it_trap044"; break;          // *** Deadly Negative Trap Kit ***
                case 15: sKit = "nw_it_trap018"; break;          // *** Average Fire Trap Kit ***
                case 16: sKit = "nw_it_trap011"; break;          // *** Strong Tangle Trap Kit ***
                case 17: sKit = "nw_it_trap022"; break;          // *** Average Electrical Trap Kit ***
                case 18: sKit = "nw_it_trap026"; break;          // *** Average Gas Trap Kit ***
                case 19: sKit = "nw_it_trap015"; break;          // *** Strong Blob of Acid Trap Kit ***
                case 20: sKit = "nw_it_trap012"; break;          // *** Deadly Tangle Trap Kit ***
                case 21: sKit = "nw_it_trap019"; break;          // *** Strong Fire Trap Kit ***
                case 22: sKit = "nw_it_trap023"; break;          // *** Strong Electrical Trap Kit ***
                case 23: sKit = "nw_it_trap016"; break;          // *** Deadly Blob of Acid Trap Kit ***
                case 24: sKit = "nw_it_trap027"; break;          // *** Strong Gas Trap Kit ***
                case 25: sKit = "nw_it_trap020"; break;          // *** Deadly Fire Trap Kit ***
                case 26: sKit = "nw_it_trap024"; break;          // *** Deadly Electrical Trap Kit ***
                case 27: sKit = "nw_it_trap028"; break;          // *** Deadly Gas Trap Kit ***
             }

        }

        CreateItemOnObject(sKit, OBJECT_SELF, 1);

    }
    void CreateHealingKit(int nRange)
    {



        string sKit = "";
        if (nRange==1)      // 200
        {
            int nRandom = Random(1) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_medkit001";  break;          // *** Healer's Kit ***
            }
        }
        else if (nRange==2)  // 800
        {
            int nRandom = Random(2) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_medkit001";  break;          // *** Healer's Kit ***
                case 2: sKit = "nw_it_medkit002";  break;          // *** Healer's Kit ***
            }

        }
        else if (nRange==3)   // 200 - 2500
        {
            int nRandom = Random(2) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_medkit002"; break;          // *** Healer's Kit ***
                case 2: sKit = "nw_it_medkit003";  break;          // *** Healer's Kit ***
            }

       }
        else if (nRange==4)  // 800 - 10000
        {
            int nRandom = Random(2) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_medkit003";break;          // *** Healer's Kit ***
                case 2: sKit = "nw_it_medkit004"; break;          // *** Healer's Kit ***
            }

        }
        else if (nRange==5)  // 2000 -16500
        {
            int nRandom = Random(2) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_medkit003"; break;          // *** Healer's Kit ***
                case 2: sKit = "nw_it_medkit004";break;          // *** Healer's Kit ***
            }

        }
        else if (nRange==6)   // 2000 - ?
        {
            int nRandom = Random(2) + 1;
            switch (nRandom)
            {
                case 1: sKit = "nw_it_medkit003"; break;          // *** Healer's Kit ***
                case 2: sKit = "nw_it_medkit004";break;          // *** Healer's Kit ***
             }

        }


        CreateItemOnObject(sKit, OBJECT_SELF, 1);

    }


    void CreateKit(int nRange)
    {
        // * April 23 2002: Major restructuring of this function
        // * to allow me to

        switch (Random(2) + 1)
        {
            case 1: CreateTraps(nRange); break;
            case 2: CreateHealingKit(nRange); break;
         }
    }

    void CreatePotion(int nRange)
    {
        string sPotion = "";


        if (nRange==1)
        {
            int nRandom = d10();
            switch (nRandom)
            {
                case 1: case 2: case 3: case 4: sPotion = "nw_it_mpotion001"; break;          // *** Potion of Cure Light Wounds ***
                case 5: case 6: case 7: sPotion = "nw_it_mpotion020";  break;          // *** Potion of Cure Light Wounds ***
                case 8: sPotion = "nw_it_mpotion002";  break;          // *** Potion of Cure Serious Wounds ***
                case 9: sPotion = "nw_it_mpotion009";  break;          // *** Potion of Bless ***
                case 10: sPotion = "nw_it_mpotion005";  break;          // *** Potion of Barkskin ***
            }

        }
        else if (nRange==2)
        {
           int nRandom = Random(29) + 1;
            switch (nRandom)
            {
                case 1: case 2: case 3: sPotion = "nw_it_mpotion001"; break;          // *** Potion of Cure Light Wounds ***
                case 4: case 5: case 6: case 7: case 8: sPotion = "nw_it_mpotion020";  break;          // *** Potion of Cure Light Wounds ***
                case 9: case 10: case 11: case 12: sPotion = "nw_it_mpotion002";  break;          // *** Potion of Cure Serious Wounds ***
                case 13: case 14: sPotion = "nw_it_mpotion003";  break;          // *** Potion of Cure Critical Wounds ***
                case 15: sPotion = "nw_it_mpotion009";  break;          // *** Potion of Bless ***
                case 16: sPotion = "nw_it_mpotion005";  break;          // *** Potion of Barkskin ***
                case 17: sPotion = "nw_it_mpotion007";  break;          // *** Potion of Clarity ***
                case 18: sPotion = "nw_it_mpotion008";  break;          // *** Potion of Invisibility ***
                case 19: sPotion = "nw_it_mpotion010";  break;          // *** Potion of Eagle's Splendor ***
                case 20: sPotion = "nw_it_mpotion011";  break;          // *** Potion of Lesser Restoration ***
                case 21: sPotion = "nw_it_mpotion013";  break;          // *** Potion of Endurance ***
                case 22: sPotion = "nw_it_mpotion014";  break;          // *** Potion of Cat's Grace ***
                case 23: sPotion = "nw_it_mpotion015";  break;          // *** Potion of Bull's Strength ***
                case 24: sPotion = "nw_it_mpotion016";  break;          // *** Potion of Aid ***
                case 25: sPotion = "nw_it_mpotion017";  break;          // *** Potion of Fox's Cunning ***
                case 26: sPotion = "nw_it_mpotion018";  break;          // *** Potion of Owl's Wisdom ***
                case 27: sPotion = "nw_it_mpotion019";  break;          // *** Potion of Lore ***
                case 28: sPotion = "nw_it_mpotion004";  break;          // *** Potion of Speed ***
                case 29: sPotion = "nw_it_mpotion006";  break;          // *** Potion of Antidote ***
            }
        }
        else if (nRange==3)
        {
           int nRandom = Random(29) + 1;
            switch (nRandom)
            {
                case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8:
                case 9: case 10: case 11: case 12:
                case 13: case 14: sPotion = "nw_it_mpotion003";  break;          // *** Potion of Cure Critical Wounds ***
                case 15: sPotion = "nw_it_mpotion009";  break;          // *** Potion of Bless ***
                case 16: sPotion = "nw_it_mpotion005";  break;          // *** Potion of Barkskin ***
                case 17: sPotion = "nw_it_mpotion007";  break;          // *** Potion of Clarity ***
                case 18: sPotion = "nw_it_mpotion008";  break;          // *** Potion of Invisibility ***
                case 19: sPotion = "nw_it_mpotion010";  break;          // *** Potion of Eagle's Splendor ***
                case 20: sPotion = "nw_it_mpotion011";  break;          // *** Potion of Lesser Restoration ***
                case 21: sPotion = "nw_it_mpotion013";  break;          // *** Potion of Endurance ***
                case 22: sPotion = "nw_it_mpotion014";  break;          // *** Potion of Cat's Grace ***
                case 23: sPotion = "nw_it_mpotion015";  break;          // *** Potion of Bull's Strength ***
                case 24: sPotion = "nw_it_mpotion016";  break;          // *** Potion of Aid ***
                case 25: sPotion = "nw_it_mpotion017";  break;          // *** Potion of Fox's Cunning ***
                case 26: sPotion = "nw_it_mpotion018";  break;          // *** Potion of Owl's Wisdom ***
                case 27: sPotion = "nw_it_mpotion019";  break;          // *** Potion of Lore ***
                case 28: sPotion = "nw_it_mpotion004";  break;          // *** Potion of Speed ***
                case 29: sPotion = "nw_it_mpotion006";  break;          // *** Potion of Antidote ***
            }
        }
        else if (nRange==4)
        {
           int nRandom = Random(29) + 1;
            switch (nRandom)
            {
                case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8:
                case 9: case 10: case 11: case 12: sPotion = "nw_it_mpotion003"; break;          // *** Potion of Cure Critical Wounds ***
                case 13: case 14: sPotion = "nw_it_mpotion003";  break;          // *** Potion of Cure Critical Wounds ***
                case 15: sPotion = "nw_it_mpotion009";  break;          // *** Potion of Bless ***
                case 16: sPotion = "nw_it_mpotion005";  break;          // *** Potion of Barkskin ***
                case 17: sPotion = "nw_it_mpotion007";  break;          // *** Potion of Clarity ***
                case 18: sPotion = "nw_it_mpotion008";  break;          // *** Potion of Invisibility ***
                case 19: sPotion = "nw_it_mpotion010";  break;          // *** Potion of Eagle's Splendor ***
                case 20: sPotion = "nw_it_mpotion011";  break;          // *** Potion of Lesser Restoration ***
                case 21: sPotion = "nw_it_mpotion013";  break;          // *** Potion of Endurance ***
                case 22: sPotion = "nw_it_mpotion014";  break;          // *** Potion of Cat's Grace ***
                case 23: sPotion = "nw_it_mpotion015";  break;          // *** Potion of Bull's Strength ***
                case 24: sPotion = "nw_it_mpotion016";  break;          // *** Potion of Aid ***
                case 25: sPotion = "nw_it_mpotion017";  break;          // *** Potion of Fox's Cunning ***
                case 26: sPotion = "nw_it_mpotion018";  break;          // *** Potion of Owl's Wisdom ***
                case 27: sPotion = "nw_it_mpotion019";  break;          // *** Potion of Lore ***
                case 28: sPotion = "nw_it_mpotion004";  break;          // *** Potion of Speed ***
                case 29: sPotion = "nw_it_mpotion006";  break;          // *** Potion of Antidote ***
            }
        }
        else  // keep 5 and 6 the same
        {
           int nRandom = Random(29) + 1;
            switch (nRandom)
            {
                case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8:
                case 9: sPotion = "nw_it_mpotion003" ;          // *** Potion of Cure Critical Wounds ***
                case 10: case 11: case 12: case 13: case 14: sPotion = "nw_it_mpotion003";  break;          // *** Potion of Cure Critical Wounds ***
                case 15: sPotion = "nw_it_mpotion009";  break;          // *** Potion of Bless ***
                case 16: sPotion = "nw_it_mpotion005";  break;          // *** Potion of Barkskin ***
                case 17: sPotion = "nw_it_mpotion007";  break;          // *** Potion of Clarity ***
                case 18: sPotion = "nw_it_mpotion008";  break;          // *** Potion of Invisibility ***
                case 19: sPotion = "nw_it_mpotion010";  break;          // *** Potion of Eagle's Splendor ***
                case 20: sPotion = "nw_it_mpotion011";  break;          // *** Potion of Lesser Restoration ***
                case 21: sPotion = "nw_it_mpotion013";  break;          // *** Potion of Endurance ***
                case 22: sPotion = "nw_it_mpotion014";  break;          // *** Potion of Cat's Grace ***
                case 23: sPotion = "nw_it_mpotion015";  break;          // *** Potion of Bull's Strength ***
                case 24: sPotion = "nw_it_mpotion016";  break;          // *** Potion of Aid ***
                case 25: sPotion = "nw_it_mpotion017";  break;          // *** Potion of Fox's Cunning ***
                case 26: sPotion = "nw_it_mpotion018";  break;          // *** Potion of Owl's Wisdom ***
                case 27: sPotion = "nw_it_mpotion019";  break;          // *** Potion of Lore ***
                case 28: sPotion = "nw_it_mpotion004";  break;          // *** Potion of Speed ***
                case 29: sPotion = "nw_it_mpotion006";  break;          // *** Potion of Antidote ***
            }
        }

        CreateItemOnObject(sPotion, OBJECT_SELF, 1);
    }

void MakeTreasure()
{

   int nProbBook =   0;
   int nProbAnimal = 0;
   int nProbJunk =   0;
   int nProbGold = 0;
   int nProbGem = 0;
   int nProbJewel = 0;
   int nProbArcane = 0;
   int nProbDivine = 0;
   int nProbAmmo = 0;
   int nProbKit = 0;
   int nProbPotion = 0;
   int nProbTable2 = 0;



int    TREASURE_LOW = 1;
int    TREASURE_MEDIUM = 2;
int    TREASURE_HIGH = 3;

 object oMob=OBJECT_SELF;
 int nChallenge=FloatToInt(GetChallengeRating(OBJECT_SELF));

// animals and insects dont have anything
  if ((GetRacialType(oMob) == RACIAL_TYPE_ANIMAL)||(GetRacialType(oMob) == RACIAL_TYPE_VERMIN))
        {
        return;
        }
/// 20 per cent chance of having something

if (Random(100)< 79)
 {
  return;
 }

 //SendMessageToAllDMs("got phat lewt");

int nTreasure=TREASURE_LOW;

if (Random(5)==1)

{
 nTreasure=TREASURE_MEDIUM;
}

if (Random(10)==1)

{
 nTreasure=TREASURE_HIGH;
}

int nRange=1;

if (nChallenge>5)
{
nRange=2;
}

if (nChallenge>8)
{
nRange=3;
}

if (nChallenge>10)
{
nRange=4;
}

if (nChallenge>13)
{
nRange=5;
}

if (nChallenge>16)
{
nRange=6;
}


int nNumber=1;
int nAmount=1;
int nDivider;
float fChallenge;


  if (nChallenge>5)
 {
  fChallenge=GetChallengeRating(OBJECT_SELF);
  nDivider=FloatToInt(fChallenge/3);
  nAmount=nDivider+Random(6)-4;
  if (nAmount<1)
    {
    nAmount=1;
    }

if (nAmount>6)
    {
    nAmount=6;
    }
 }

 // * AMOUNT OF GOLD BY VALUE
    float LOW_MOD_GOLD = 0.5;   float MEDIUM_MOD_GOLD = 1.0; float HIGH_MOD_GOLD = 3.0;
    // * FREQUENCY OF ITEM TYPE APPEARING BY TREASURE TYPE
    int LOW_PROB_BOOK    = 0;  int MEDIUM_PROB_BOOK =   0;  int HIGH_PROB_BOOK =0;
    int LOW_PROB_ANIMAL  = 0;  int MEDIUM_PROB_ANIMAL = 0;  int HIGH_PROB_ANIMAL = 0;
    int LOW_PROB_JUNK    = 2;  int MEDIUM_PROB_JUNK =    0;  int HIGH_PROB_JUNK = 0;
    int LOW_PROB_GOLD = 69;    int MEDIUM_PROB_GOLD =   63; int HIGH_PROB_GOLD = 27;
    int LOW_PROB_GEM  = 9;     int MEDIUM_PROB_GEM =    15; int HIGH_PROB_GEM = 41;
    int LOW_PROB_JEWEL = 4;    int MEDIUM_PROB_JEWEL =  11; int HIGH_PROB_JEWEL = 15;
    int LOW_PROB_ARCANE = 1;   int MEDIUM_PROB_ARCANE = 1; int HIGH_PROB_ARCANE = 1;
    int LOW_PROB_DIVINE = 3;   int MEDIUM_PROB_DIVINE = 3;  int HIGH_PROB_DIVINE = 7;
    int LOW_PROB_AMMO = 10;    int MEDIUM_PROB_AMMO =   5;  int HIGH_PROB_AMMO  =   3;
    int LOW_PROB_KIT = 1;      int MEDIUM_PROB_KIT =    1;  int HIGH_PROB_KIT   =   1;
    int LOW_PROB_POTION =1;   int MEDIUM_PROB_POTION = 1; int HIGH_PROB_POTION=   5;
    int LOW_PROB_TABLE2 = 0;   int MEDIUM_PROB_TABLE2 = 0; int HIGH_PROB_TABLE2=   0;


 if (nTreasure == TREASURE_LOW)
   {
    nProbBook   = LOW_PROB_BOOK;
    nProbAnimal = LOW_PROB_ANIMAL;
    nProbJunk   = LOW_PROB_JUNK;
    nProbGold   = LOW_PROB_GOLD;
    nProbGem    = LOW_PROB_GEM;
    nProbJewel  = LOW_PROB_JEWEL;
    nProbArcane = LOW_PROB_ARCANE;
    nProbDivine  = LOW_PROB_DIVINE;
    nProbAmmo = LOW_PROB_AMMO ;
    nProbKit = LOW_PROB_KIT;
    nProbPotion = LOW_PROB_POTION;
    nProbTable2 = LOW_PROB_TABLE2;
   }
   else if (nTreasure == TREASURE_MEDIUM)
   {
    nProbBook   = MEDIUM_PROB_BOOK;
    nProbAnimal = MEDIUM_PROB_ANIMAL;
    nProbJunk   = MEDIUM_PROB_JUNK;
    nProbGold   = MEDIUM_PROB_GOLD;
    nProbGem    = MEDIUM_PROB_GEM;
    nProbJewel  = MEDIUM_PROB_JEWEL;
    nProbArcane = MEDIUM_PROB_ARCANE;
    nProbDivine  = MEDIUM_PROB_DIVINE;
    nProbAmmo = MEDIUM_PROB_AMMO ;
    nProbKit = MEDIUM_PROB_KIT;
    nProbPotion = MEDIUM_PROB_POTION;
    nProbTable2 = MEDIUM_PROB_TABLE2;
   }
   else if (nTreasure == TREASURE_HIGH)
   {
    nProbBook   = HIGH_PROB_BOOK;
    nProbAnimal = HIGH_PROB_ANIMAL;
    nProbJunk   = HIGH_PROB_JUNK;
    nProbGold   = HIGH_PROB_GOLD;
    nProbGem    = HIGH_PROB_GEM;
    nProbJewel  = HIGH_PROB_JEWEL;
    nProbArcane = HIGH_PROB_ARCANE;
    nProbDivine  = HIGH_PROB_DIVINE;
    nProbAmmo = HIGH_PROB_AMMO ;
    nProbKit = HIGH_PROB_KIT;
    nProbPotion = HIGH_PROB_POTION;
    nProbTable2 = HIGH_PROB_TABLE2;
   }

int i=1;
for (i = 1; i <= nAmount; i++)
   {
     int nRandom = d100();
     if (nRandom <= nProbBook)
        CreateBook(OBJECT_SELF);                                // * Book
     else if (nRandom <= nProbBook + nProbAnimal)
        CreateAnimalPart(OBJECT_SELF);                          // * Animal
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk)
        CreateJunk(OBJECT_SELF);                                // * Junk
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold)
        CreateGold(nRange, nTreasure);    // * Gold
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold + nProbGem)
        CreateGem(nRange, nTreasure);     // * Gem
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold + nProbGem + nProbJewel)
        CreateJewel(nRange,nTreasure);   // * Jewel
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold + nProbGem + nProbJewel + nProbArcane)
        CreateArcaneScroll(nRange);   // * Arcane Scroll
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold + nProbGem + nProbJewel + nProbArcane + nProbDivine)
        CreateDivineScroll(nRange);   // * Divine Scroll
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold + nProbGem + nProbJewel + nProbArcane + nProbDivine + nProbAmmo)
        CreateAmmo(nRange);   // * Ammo
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold + nProbGem + nProbJewel + nProbArcane + nProbDivine + nProbAmmo + nProbKit)
        CreateKit(nRange);   // * Healing, Trap, or Thief kit
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold + nProbGem + nProbJewel + nProbArcane + nProbDivine + nProbAmmo + nProbKit + nProbPotion)
        CreatePotion(nRange);   // * Potion
     else if (nRandom <= nProbBook + nProbAnimal + nProbJunk + nProbGold + nProbGem + nProbJewel + nProbArcane + nProbDivine + nProbAmmo + nProbKit + nProbPotion + nProbTable2)
     {
       // CreateTable2Item(oCreateOn, oLastOpener, nSpecific);   // * Weapons, Armor, Misc - Class based
     }


}
}


